#!/usr/local/bin/perl

sub diagnostic_message {

    local($code, $msg) = @_;

    local($dmsgs) = '';

    open(DMSGS, "awk '/^$code / {print; for (getline; \$0 ~ /^ /; getline) {print}}' diag-msg |");

    while (<DMSGS>) { chop; s/^[0-9]+//; s/^ +//; $dmsgs .= ' ' if ($dmsgs); $dmsgs .= $_; }

    close(DMSGS);

    $diagmsg = ($dmsgs) ? $dmsgs : 'Unknown diagnostic ' . $code . $/;

    return ($msg) ? $msg . ' [' . $diagmsg . ']' : $diagmsg;
}

1; #return true
